/* Image.c generated by valac 0.56.18-dirty, the Vala compiler
 * generated from Image.vala, do not modify */

/*
 * Copyright 2015 Corentin Noël
 * Copyright 2025 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <cogl/cogl.h>
#include <clutter/clutter.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_IMAGE_0_PROPERTY,
	GALA_IMAGE_NUM_PROPERTIES
};
static GParamSpec* gala_image_properties[GALA_IMAGE_NUM_PROPERTIES];

static gpointer gala_image_parent_class = NULL;

static GType gala_image_get_type_once (void);

GalaImage*
gala_image_construct_from_pixbuf (GType object_type,
                                  GdkPixbuf* pixbuf)
{
	GalaImage * self = NULL;
	CoglPixelFormat _tmp0_ = 0;
	CoglPixelFormat pixel_format = 0;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (pixbuf != NULL, NULL);
	self = (GalaImage*) g_object_new (object_type, NULL);
	if (gdk_pixbuf_get_has_alpha (pixbuf)) {
		_tmp0_ = COGL_PIXEL_FORMAT_RGBA_8888;
	} else {
		_tmp0_ = COGL_PIXEL_FORMAT_RGB_888;
	}
	pixel_format = _tmp0_;
	{
		guint8* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		_tmp1_ = gdk_pixbuf_get_pixels (pixbuf);
		_tmp2_ = gdk_pixbuf_get_width (pixbuf);
		_tmp3_ = _tmp2_;
		_tmp4_ = gdk_pixbuf_get_height (pixbuf);
		_tmp5_ = _tmp4_;
		_tmp6_ = gdk_pixbuf_get_rowstride (pixbuf);
		_tmp7_ = _tmp6_;
		clutter_image_set_data ((ClutterImage*) self, _tmp1_, pixel_format, (guint) _tmp3_, (guint) _tmp5_, (guint) _tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

GalaImage*
gala_image_new_from_pixbuf (GdkPixbuf* pixbuf)
{
	return gala_image_construct_from_pixbuf (GALA_TYPE_IMAGE, pixbuf);
}

GalaImage*
gala_image_construct (GType object_type)
{
	GalaImage * self = NULL;
	self = (GalaImage*) g_object_new (object_type, NULL);
	return self;
}

GalaImage*
gala_image_new (void)
{
	return gala_image_construct (GALA_TYPE_IMAGE);
}

static void
gala_image_class_init (GalaImageClass * klass,
                       gpointer klass_data)
{
	gala_image_parent_class = g_type_class_peek_parent (klass);
}

static void
gala_image_instance_init (GalaImage * self,
                          gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
gala_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaImage), 0, (GInstanceInitFunc) gala_image_instance_init, NULL };
	GType gala_image_type_id;
	gala_image_type_id = g_type_register_static (clutter_image_get_type (), "GalaImage", &g_define_type_info, 0);
	return gala_image_type_id;
}

GType
gala_image_get_type (void)
{
	static gsize gala_image_type_id__once = 0;
	if (g_once_init_enter (&gala_image_type_id__once)) {
		GType gala_image_type_id;
		gala_image_type_id = gala_image_get_type_once ();
		g_once_init_leave (&gala_image_type_id__once, gala_image_type_id);
	}
	return gala_image_type_id__once;
}

